#!/usr/bin/env python

import wave, struct
SAMPLE_RATE = 96000 
TRIANGLE=10000.0 # Hz

original = wave.open("dalva1000.wav", "r")

filtered = wave.open("dalva_pwm2.wav", "w")
filtered.setnchannels(1)
filtered.setsampwidth(2)
filtered.setframerate(SAMPLE_RATE)

n = original.getnframes()
original = struct.unpack('%dh' % n, original.readframes(n))
original = [s / 2.0**15 for s in original]

result = []
trivalue = 0.0
tristep = TRIANGLE / SAMPLE_RATE

for i in range(0, len(original)):
	value = original[i]
	sign = 1
	if value < 0:
		sign = -1
	if abs(value) > trivalue:
		result.append(sign * 0.8)
	else:
		result.append(0)

	trivalue += tristep
	if trivalue > 1.0:
		tristep *= -1
		excess = trivalue - 1.0
		trivalue -= excess * 2
	elif trivalue < 0:
		tristep *= -1
		excess = trivalue
		trivalue -= excess * 2

result = [ sample * 2.0**15 for sample in result ]
filtered.writeframes(struct.pack('%dh' % len(result), *result))
